//   picavr@mail.ru
// 64  .   ,    -   PIC 
#include 64bit_aritmetic.h

unlong_long bit_clr64 (unlong_long temp,unchar num_bit){//   
if(num_bit<32){temp.w[0]=(temp.w[0] & (0xFFFF ^ (1<<(num_bit))));return temp;}
if(num_bit<63){temp.w[1]=(temp.w[1] & (0xFFFF ^ (1<<(num_bit+32))));return temp;}}
//-------------------------------------------------------------------------------------------------
unlong_long bit_set64 (unlong_long temp,unchar num_bit){// 64 ,  ,     ,  64 
//if(num_bit>63)return temp; //
if(num_bit<16){temp.d[0]=(temp.d[0] | (1<<(num_bit)));return temp;}
if(num_bit<32){temp.d[1]=(temp.d[1] | (1<<(num_bit-16)));return temp;}
if(num_bit<48){temp.d[2]=(temp.d[2] | (1<<(num_bit-32)));return temp;}
if(num_bit<64){temp.d[3]=(temp.d[3] | (1<<(num_bit-48)));return temp;}
return temp;}
//-------------------------------------------------------------------------------------------------
unchar bit_test64 (unlong_long temp,unchar num_bit){//   
/*
if(num_bit<32){if(((temp.w[0]>>num_bit) & 0x00000001)>0){return 1;}else{return 0;}}//
if(num_bit<64){if(((temp.w[1]>>(num_bit-32)) & 0x00000001)>0){return 1;}else{return 0;}}//
*/
if(num_bit<16){if(((temp.d[0]>>(num_bit-00)) & 0x0001)>1)return 1;}
if(num_bit<32){if(((temp.d[1]>>(num_bit-16)) & 0x0001)>1)return 1;}
if(num_bit<48){if(((temp.d[2]>>(num_bit-32)) & 0x0001)>1)return 1;}
if(num_bit<64){if(((temp.d[3]>>(num_bit-48)) & 0x0001)>1)return 1;}
return 0;}
//-------------------------------------------------------------------------------------------------
/*
unchar bit_test32 (unlong temp,unchar num_bit){// 32 ,  ,    ,    =0  1
if(num_bit<16){if(((temp.d[0]>>(num_bit-00)) & 0x0001)>1)return 1;}
if(num_bit<32){if(((temp.d[1]>>(num_bit-16)) & 0x0001)>1)return 1;}
return 0;}
*/
//-------------------------------------------------------------------------------------------------
unint bit_test32 (unlong temp,unchar num_bit){//   
unint temp1;
if(num_bit<32){if(((temp>>num_bit) & 0x0001)>0){return 1;}
else{return 0;}}
}
//-------------------------------------------------------------------------------------------------
#define macro_clear_64(x) x.w[0]=0;x.w[1]=0;
#define macro_set_64(x) x.w[0]=0xffffffff;x.w[1]=0xffffffff;
#define macro_load_64(x,a,b) x.w[1]=a;x.w[0]=b;
//-------------------------------------------------------------------------------------------------
unlong_long clear_64(void){//
unlong_long temp;
	temp.w[0]=0;
	temp.w[1]=0;
  return temp;}
//-------------------------------------------------------------------------------------------------
unlong_long shift_left64(unlong_long temp){// 
	temp.w[1]=temp.w[1]<<1;
	if((temp.w[0] & 0x80000000)>0)
	{temp.w[1]=temp.w[1] | 0x01;}
	temp.w[0]=temp.w[0]<<1;
	return temp;}
//-------------------------------------------------------------------------------------------------
unlong_long shift_right64(unlong_long temp){// 
	temp.w[0]=temp.w[0]>>1;
	if((temp.w[1] & 0x00000001)>0)
	{temp.w[0]=temp.w[0] | 0x80000000;}
	temp.w[1]=temp.w[1]>>1;
	return temp;}
//-------------------------------------------------------------------------------------------------
unlong sub_add_64(unlong a, unlong b, unchar c){//  
	return a+b+c;}
//-------------------------------------------------------------------------------------------------
unlong_long add_64 (unlong_long a,unlong_long b){// a=a+b
unlong temp;unchar tempadd;
	temp=sub_add_64(a.d[0],b.d[0],tempadd);a.d[0]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=sub_add_64(a.d[1],b.d[1],tempadd);a.d[1]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=sub_add_64(a.d[2],b.d[2],tempadd);a.d[2]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=sub_add_64(a.d[3],b.d[3],tempadd);
	a.d[3]=temp;
	return a;}
//-------------------------------------------------------------------------------------------------
/*
unlong_long add_64 (unlong_long a,unlong_long b){// a=a+b
unlong temp;unchar tempadd;
	temp=((unlong)(a.d[0]))+((unlong)(b.d[0]));a.d[0]=temp;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=((unlong)(a.d[1]))+((unlong)(b.d[1]))+tempadd;a.d[1]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=((unlong)(a.d[2]))+((unlong)(b.d[2]))+tempadd;a.d[2]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=a.d[3]+b.d[3]+tempadd;a.d[3]=temp;
	return a;
}
*/
//-------------------------------------------------------------------------------------------------
unlong sub_sub_64(unlong a, unlong b, unchar c){//  
	return a-b-c;}
//-------------------------------------------------------------------------------------------------
unlong_long sub_64 (unlong_long a,unlong_long b){// a=a+b, CARRY  
unlong temp;unchar tempsub=0;
	temp=sub_sub_64(a.d[0],b.d[0],tempsub);a.d[0]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=sub_sub_64(a.d[1],b.d[1],tempsub);a.d[1]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=sub_sub_64(a.d[2],b.d[2],tempsub);a.d[2]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=sub_sub_64(a.d[3],b.d[3],tempsub);a.d[3]=temp;
	if((temp & 0xffff0000)>0){CARRY=1;}else{CARRY=0;} 
	return a;}
/*
//-------------------------------------------------------------------------------------------------
unlong_long sub_64 (unlong_long a,unlong_long b){// a=a+b
unlong temp;unchar tempsub;
	temp=((unlong)(a.d[0]))-((unlong)(b.d[0]));
	a.d[0]=temp;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=((unlong)(a.d[1]))-((unlong)(b.d[1]))-tempsub;
	a.d[1]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=((unlong)(a.d[2]))-((unlong)(b.d[2]))-tempsub;
	a.d[2]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=((unlong)(a.d[3]))-((unlong)(b.d[3]))-tempsub;
	a.d[3]=temp;
	return a;
}
*/
//-------------------------------------------------------------------------------------------------
#define compare_64 sub_64	//, a=a-b, CARRY  
/*
//-------------------------------------------------------------------------------------------------
void compare_64 (unlong_long a,unlong_long b){// 64  
	sub_64 (a,b);// a=a-b
  if (CARRY==0) BORROW=TRUE; 
  else BORROW=FALSE;}
*/
//-------------------------------------------------------------------------------------------------
unlong_long convert32_64(unlong a) { 
   //routine to convert a 32bit int to 64bit 
unlong_long temp;unint i; 
   temp.w[0]=a;   //and clear the top half 
   temp.w[1]=0L; 
   return temp; 
} 
//-------------------------------------------------------------------------------------------------
unlong_long mult32_32(unlong a,unlong b){//Routine to multiply two 32bit values with a 64bit result 
unlong_long temp1,temp64;unchar i; 
//	macro_clear_64(temp64);
//	temp64=clear_64();
	temp1.w[0]=a;
	temp1.w[1]=0;
  scratch64.w[0]=b;
  scratch64.w[1]=0;
	for(i=0;i<32;i++)
	{	if((bit_test64(temp1,i))>0)
		{temp64=add_64(temp64,scratch64);}
		scratch64=shift_left64(scratch64);}
	return temp64;} 
//-------------------------------------------------------------------------------------------------
unchar check_zero_64(unlong_long a){//  0 64  
unchar temp;
	if(((a.w[0]) ^ (a.w[1]))==0){
temp=TRUE;}
	else{
temp=FALSE;}
	return temp;
} 
//-------------------------------------------------------------------------------------------------
unlong_long div_64 (unlong_long a,unlong_long b){// a=a+b
unlong_long temp;unchar num_bit,ctr;
	if(check_zero_64(b)==TRUE){						//  0 64  
		if(check_zero_64(b)==FALSE){				//  0 64  
        //need maximum result
		    temp.w[0]=temp.w[1]=0xFFFFFFFF;	//macro_set_64(temp);}
				macro_clear_64(scratch64);
				return temp;
		}
		//	else{
		macro_clear_64(temp);
		macro_clear_64(scratch64);					//macro_load_64(temp,0,1);//} 
    temp.b[0]=1;
		return temp;
    //return 1
	}
	macro_clear_64(temp);
	num_bit=0;
  //Now position divisor to suit find top bit in A, and rotate b till it's
  //top bit is in the same position
	if (a.w[1]!=0){ 
		for(ctr=31;
!bit_test32(a.w[1],ctr);
ctr--);		//for(ctr=31;!bit_test(a.w[1],ctr);ctr--); 
    //Now rotate b till it's top bit matches.
		while (!bit_test32(b.w[1],ctr)){		//while (!bit_test(b.w[1],ctr))
			b=shift_left64(b);
			num_bit++;
		}
	}
	else 	{ 
		for(ctr=31;!bit_test32(a.w[0],ctr);ctr--) ; 
		num_bit=ctr; 
    //Now rotate b till it's top bit matches.
		while (!bit_test32(b.w[1],ctr))	{
			b=shift_left64(b);
			num_bit++;
		}
	}      
  //num_bit now stores how far b had to rotate
	while (num_bit) {											//num_bit now stores how far b had to rotate 
		//Loop for num_bit bits, performing subtract, shift & test 
		scratch64=compare_64(a,b); 				//		scratch64=I_A_LT_B(a,b); 
		if (CARRY==0)	{ 
			a=scratch64; 										//Set output bit if no borrow 
      //Set output bit if no borrow
			temp=bit_set64(temp,num_bit); 
		}
		if (check_zero_64(b)==1)	break;
		b=shift_right64(b);
		num_bit--; 
 	} 
	scratch64=a; 
	return temp; 
}
/*
int64 div64x64(int64 a,int64 b) {  //Routine to divide 'a' by 'b' in 64bit arithmetic returns with result, leaving remainder in the scratch64 
int8 num_bit=0,ctr;int64 temp; 
	if (M_iszero64(b)) 
	{ 
		if (!M_iszero64(a))
		{ 
			//need maximum result 
			temp.w[0]=temp.w[1]=0xFFFFFFFF; 
			M_zero64(scratch64);//=0
			return temp; 			//return 0 
		} 
		//Else 0/0=1 
		M_zero64(temp); 		//=0
		M_zero64(scratch64);//=0 
		temp.b[0]=1; 
		return temp;       //return 1 
	}
	M_zero64(temp); 
	num_bit=0; 
	//Now position divisor to suit find top bit in A, and rotate b till it's 
	//top bit is in the same position 
	if (a.w[1]!=0) 
	{ 
		for(ctr=31;!bit_test(a.w[1], ctr);ctr--); 
			//Now rotate b till it's top bit matches. 
		while (!bit_test(b.w[1], ctr)) 
		{ 
      	M_shiftleft64(b); 
      	++num_bit; 
		} 
	} 
	else 
	{ 
		for(ctr=31;!bit_test(a.w[0], ctr);ctr--) ; 
		num_bit=ctr; 
		//Now rotate b till it's top bit matches. 
		while (!bit_test(b.w[1], ctr))
		{
			M_shiftleft64(b); 
			++num_bit; 
		}
	}      
  //num_bit now stores how far b had to rotate 
	while (num_bit) 
	{ 
		//Loop for num_bit bits, performing subtract, shift & test 
		scratch64=I_A_LT_B(a,b); 
		if (!BORROW) 
		{ 
			a=scratch64; 
			//Set output bit if no borrow 
			bit64_set(temp,num_bit); 
		}
		if (M_iszero64(a)) break; 
		M_shiftright64(b); 
		num_bit--; 
 	} 
	scratch64=a; 
	return temp; 
}
*/
/*
//-------------------------------------------------------------------------------------------------
int64 clear_64(void){//,  64=0  
int64 temp;
   temp.w[0]=0;
   temp.w[1]=0;
  return temp;}
//-------------------------------------------------------------------------------------------------
int64 shift_left64(int64 temp){// 64 ,    1 ,  64 
   temp.w[1]=temp.w[1]<<1;
   if((temp.w[0] & 0x80000000)>0)
   {temp.w[1]=temp.w[1] | 0x01;}
   temp.w[0]=temp.w[0]<<1;
   return temp;}
//-------------------------------------------------------------------------------------------------
int64 shift_right64(int64 temp){// 64 ,    1 ,  64 
   temp.w[0]=temp.w[0]>>1;
   if((temp.w[1] & 0x00000001)>0)
   {temp.w[0]=temp.w[0] | 0x80000000;}
   temp.w[1]=temp.w[1]>>1;
   return temp;}
//-------------------------------------------------------------------------------------------------
int64 bit_set64 (int64 temp,unchar num_bit){// 64 ,  ,     ,  64 
//if(num_bit>63)return temp;
if(num_bit<16){temp.d[0]=(temp.d[0] | (1<<(num_bit)));return temp;}
if(num_bit<32){temp.d[1]=(temp.d[1] | (1<<(num_bit-16)));return temp;}
if(num_bit<48){temp.d[2]=(temp.d[2] | (1<<(num_bit-32)));return temp;}
if(num_bit<64){temp.d[3]=(temp.d[3] | (1<<(num_bit-48)));return temp;}
return temp;}
//-------------------------------------------------------------------------------------------------
int64 bit_clr64 (int64 temp,unchar num_bit){// 64 ,  ,    ,  64 
//if(num_bit>63)return temp;
if(num_bit<16){temp.d[0]=(temp.d[0] & (0xFFFF ^ (1<<(num_bit))));return temp;}
if(num_bit<32){temp.d[1]=(temp.d[1] & (0xFFFF ^ (1<<(num_bit-16))));return temp;}
if(num_bit<48){temp.d[2]=(temp.d[2] & (0xFFFF ^ (1<<(num_bit-32))));return temp;}
if(num_bit<64){temp.d[3]=(temp.d[3] & (0xFFFF ^ (1<<(num_bit-48))));return temp;}
return temp;}
//-------------------------------------------------------------------------------------------------
unint bit_test64 (int64 temp,unchar num_bit){// 64 ,  ,    ,    =0  1
unint temp1;
//if(num_bit>63)return temp;
if(num_bit<16){temp1=((temp.d[0]>>num_bit) & 0x0001);return temp1;}
if(num_bit<32){temp1=((temp.d[1]>>(num_bit-16)) & 0x0001);return temp1;}
if(num_bit<48){temp1=((temp.d[2]>>(num_bit-32)) & 0x0001);return temp1;}
if(num_bit<64){temp1=((temp.d[3]>>(num_bit-48)) & 0x0001);return temp1;}
return temp1;}
//-------------------------------------------------------------------------------------------------
//1  222byt/227mks(20), Hitech PIC16
int64 add_64 (int64 a,int64 b){// a=a+b,    64 ,  64 
unlong temp;unint tempadd;
   temp=((unlong)(a.d[0]))+((unlong)(b.d[0]));a.d[0]=temp;
   if((temp & 0x10000)>0){tempadd=1;}
   temp=((unlong)(a.d[1]))+((unlong)(b.d[1]))+tempadd;a.d[1]=temp;tempadd=0;
   if((temp & 0x10000)>0){tempadd=1;}
   temp=((unlong)(a.d[2]))+((unlong)(b.d[2]))+tempadd;a.d[2]=temp;tempadd=0;
   if((temp & 0x10000)>0){tempadd=1;}
   temp=a.d[3]+b.d[3]+tempadd;a.d[3]=temp;
   return a;}
//-------------------------------------------------------------------------------------------------
//2  87byt/251mks(20) Hitech PIC16
unlong sub_add_64(unlong a, unlong b, unchar c){//  
   return a+b+c;}
int64 add_64 (int64 a,int64 b){// a=a+b,    64 ,  64 
unlong temp;unint tempadd;
   temp=sub_add_64(a.d[0],b.d[0],tempadd);   a.d[0]=temp;tempadd=0;
   if((temp & 0x10000)>0){tempadd=1;}
   temp=sub_add_64(a.d[1],b.d[1],tempadd);   a.d[1]=temp;tempadd=0;
   if((temp & 0x10000)>0){tempadd=1;}
   temp=sub_add_64(a.d[2],b.d[2],tempadd);   a.d[2]=temp;tempadd=0;
   if((temp & 0x10000)>0){tempadd=1;}
   temp=sub_add_64(a.d[3],b.d[3],tempadd);   a.d[3]=temp;
   return a;}
//-------------------------------------------------------------------------------------------------
//1  240byt/231mks(20), Hitech PIC16
int64 sub_64 (int64 a,int64 b){// a=a-b     64 ,  64 
unlong temp;unint tempsub;
   temp=((unlong)(a.d[0]))-((unlong)(b.d[0]));a.d[0]=temp;
   if((temp & 0xffff0000)>0){tempsub=1;}
   temp=((unlong)(a.d[1]))-((unlong)(b.d[1]))-tempsub;a.d[1]=temp;tempsub=0;
   if((temp & 0xffff0000)>0){tempsub=1;}
   temp=((unlong)(a.d[2]))-((unlong)(b.d[2]))-tempsub;a.d[2]=temp;tempsub=0;
   if((temp & 0xffff0000)>0){tempsub=1;}
   temp=((unlong)(a.d[3]))-((unlong)(b.d[3]))-tempsub;a.d[3]=temp;
   return a;}
//-------------------------------------------------------------------------------------------------
//1  173byt/252mks(20), Hitech PIC16
unlong sub_sub_64(unlong a, unlong b, unchar c){//   
   return a-b-c;}
int64 sub_64 (int64 a,int64 b){// a=a-b,    64 ,  64 
unlong temp;unchar tempsub;
   temp=sub_sub_64(a.d[0],b.d[0],tempsub);a.d[0]=temp;
   if((temp & 0xffff0000)>0){tempsub=1;}
   temp=sub_sub_64(a.d[1],b.d[1],tempsub);a.d[1]=temp;tempsub=0;
   if((temp & 0xffff0000)>0){tempsub=1;}
   temp=sub_sub_64(a.d[2],b.d[2],tempsub);a.d[2]=temp;tempsub=0;
   if((temp & 0xffff0000)>0){tempsub=1;}
   temp=sub_sub_64(a.d[3],b.d[3],tempsub);a.d[3]=temp;
   return a;}
//-------------------------------------------------------------------------------------------------














/*
//-------------------------------------------------------------------------------------------------
unlong_long bit_clr64 (unlong_long temp,unchar num_bit){//   
if(num_bit<16){temp.d[0]=(temp.d[0] & (0xFFFF ^ (1<<(num_bit))));return temp;}
if(num_bit<32){temp.d[1]=(temp.d[1] & (0xFFFF ^ (1<<(num_bit-16))));return temp;}
if(num_bit<48){temp.d[2]=(temp.d[2] & (0xFFFF ^ (1<<(num_bit-32))));return temp;}
if(num_bit<64){temp.d[3]=(temp.d[3] & (0xFFFF ^ (1<<(num_bit-48))));return temp;}
return temp;}
//-------------------------------------------------------------------------------------------------
unlong_long bit_set64 (unlong_long temp,unchar num_bit){//   
if(num_bit<16){temp.d[0]=(temp.d[0] | (1<<(num_bit)));return temp;}
if(num_bit<32){temp.d[1]=(temp.d[1] | (1<<(num_bit-16)));return temp;}
if(num_bit<48){temp.d[2]=(temp.d[2] | (1<<(num_bit-32)));return temp;}
if(num_bit<64){temp.d[3]=(temp.d[3] | (1<<(num_bit-48)));return temp;}
return temp;}
//-------------------------------------------------------------------------------------------------
unint bit_test64 (unlong_long temp,unchar num_bit){//   
unint temp1;
if(num_bit<16){temp1=((temp.d[0]>>num_bit) & 0x0001);return temp1;}
if(num_bit<32){temp1=((temp.d[1]>>(num_bit-16)) & 0x0001);return temp1;}
if(num_bit<48){temp1=((temp.d[2]>>(num_bit-32)) & 0x0001);return temp1;}
if(num_bit<64){temp1=((temp.d[3]>>(num_bit-48)) & 0x0001);return temp1;}
return temp1;}
//-------------------------------------------------------------------------------------------------
unlong_long clear_64(void){//
unlong_long temp;
	temp.w[0]=0;
	temp.w[1]=0;
  return temp;
}
//-------------------------------------------------------------------------------------------------
unlong_long shift_left64(unlong_long temp){// 
	temp.w[1]=temp.w[1]<<1;
	if((temp.w[0] & 0x80000000)>0)
	{temp.w[1]=temp.w[1] | 0x01;}
	temp.w[0]=temp.w[0]<<1;
	return temp;
}
//-------------------------------------------------------------------------------------------------
unlong_long shift_right64(unlong_long temp){// 
	temp.w[0]=temp.w[0]>>1;
	if((temp.w[1] & 0x00000001)>0)
	{temp.w[0]=temp.w[0] | 0x80000000;}
	temp.w[1]=temp.w[1]>>1;
	return temp;
}
//-------------------------------------------------------------------------------------------------
unlong sub_add_64(unlong a, unlong b, unchar c){//  
	return a+b+c;}
//-------------------------------------------------------------------------------------------------
unlong_long add_64 (unlong_long a,unlong_long b){// a=a+b
unlong temp;unchar tempadd;
	temp=sub_add_64(a.d[0],b.d[0],tempadd);a.d[0]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=sub_add_64(a.d[1],b.d[1],tempadd);a.d[1]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=sub_add_64(a.d[2],b.d[2],tempadd);a.d[2]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=sub_add_64(a.d[3],b.d[3],tempadd);
	a.d[3]=temp;
	return a;}
//-------------------------------------------------------------------------------------------------
unlong_long add_64 (unlong_long a,unlong_long b){// a=a+b
unlong temp;unchar tempadd;
	temp=((unlong)(a.d[0]))+((unlong)(b.d[0]));a.d[0]=temp;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=((unlong)(a.d[1]))+((unlong)(b.d[1]))+tempadd;a.d[1]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=((unlong)(a.d[2]))+((unlong)(b.d[2]))+tempadd;a.d[2]=temp;tempadd=0;
	if((temp & 0x10000)>0){tempadd=1;}
	temp=a.d[3]+b.d[3]+tempadd;a.d[3]=temp;
	return a;
}
//-------------------------------------------------------------------------------------------------
unlong sub_sub_64(unlong a, unlong b, unchar c){//  
	return a-b-c;}
//-------------------------------------------------------------------------------------------------
unlong_long sub_64 (unlong_long a,unlong_long b){// a=a+b, CARRY  
unlong temp;unchar tempsub;
	temp=sub_sub_64(a.d[0],b.d[0],tempsub);a.d[0]=temp;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=sub_sub_64(a.d[1],b.d[1],tempsub);a.d[1]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=sub_sub_64(a.d[2],b.d[2],tempsub);a.d[2]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=sub_sub_64(a.d[3],b.d[3],tempsub);a.d[3]=temp;
	if((temp & 0xffff0000)>0){CARRY=TRUE;}
	else{CARRY=FALSE;} 
	return a;
}
//-------------------------------------------------------------------------------------------------
unlong_long sub_64 (unlong_long a,unlong_long b){// a=a+b
unlong temp;unchar tempsub;
	temp=((unlong)(a.d[0]))-((unlong)(b.d[0]));
	a.d[0]=temp;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=((unlong)(a.d[1]))-((unlong)(b.d[1]))-tempsub;
	a.d[1]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=((unlong)(a.d[2]))-((unlong)(b.d[2]))-tempsub;
	a.d[2]=temp;tempsub=0;
	if((temp & 0xffff0000)>0){tempsub=1;}
	temp=((unlong)(a.d[3]))-((unlong)(b.d[3]))-tempsub;
	a.d[3]=temp;
	return a;
}
//-------------------------------------------------------------------------------------------------
#define compare_64 sub_64	//, a=a-b, CARRY  
//-------------------------------------------------------------------------------------------------
void compare_64 (unlong_long a,unlong_long b){// 64  
	sub_64 (a,b);// a=a-b
  if (CARRY==0) BORROW=TRUE; 
  else BORROW=FALSE;}
//-------------------------------------------------------------------------------------------------
unlong_long convert32x64(unlong a) { 
   //routine to convert a 32bit int to 64bit 
unlong_long temp;unint i; 
   temp.w[0]=a;   //and clear the top half 
   temp.w[1]=0L; 
   return temp; 
} 
*/